import com.cycling74.max.*;

public class mat2axis extends MaxObject
{

	private static final String[] INLET_ASSIST = new String[]{
		"inlet 1 help"
	};
	private static final String[] OUTLET_ASSIST = new String[]{
		"outlet 1 help"
	};
	
	public mat2axis(Atom[] args)
	{
		declareInlets(new int[]{DataTypes.ALL});
		declareOutlets(new int[]{DataTypes.ALL, DataTypes.ALL, DataTypes.ALL, DataTypes.ALL});
		
	//	setInletAssist(INLET_ASSIST);
	//	setOutletAssist(OUTLET_ASSIST);

	}
    
//	public void bang()
//	{
//	}
    
//	public void inlet(int i)
//	{
//	}
    
//	public void inlet(float f)
//	{
//	}
    
    
	public void list(Atom[] rm)
	{

		double m[] = new double[9];
		for(int i=0;i<9;i++) {
			m[i]=rm[i].getFloat();
	
		}

/**
This requires a pure rotation matrix 'm' as input.
*/
//public axisAngle toAxisAngle(matrix m) {
  double angle,x,y,z; // variables for result
	double epsilon = 0.01; // margin to allow for rounding errors
	double epsilon2 = 0.1; // margin to distinguish between 0 and 180 degrees
	// optional check that input is pure rotation, 'isRotationMatrix' is defined at:
	// http://www.euclideanspace.com/maths/algebra/matrix/orthogonal/rotation/
//	assert isRotationMatrix(m) : "not valid rotation matrix" ;// for debugging
/*	if ((Math.abs(m[3]-m[1])< epsilon)
	  && (Math.abs(m[6]-m[2])< epsilon)
	  && (Math.abs(m[7]-m[5])< epsilon)) {
		// singularity found
		// first check for identity matrix which must have +1 for all terms
		//  in leading diagonaland zero in other terms
		if ((Math.abs(m[3]+m[1]) < epsilon2)
		  && (Math.abs(m[6]+m[2]) < epsilon2)
		  && (Math.abs(m[7]+m[5]) < epsilon2)
		  && (Math.abs(m[0]+m[4]+m[8]-3) < epsilon2)) {
			// this singularity is identity matrix so angle = 0
			return new axisAngle(0,1,0,0); // zero angle, arbitrary axis
		}
		// otherwise this singularity is angle = 180
		angle = Math.PI;
		double xx = (m[0]+1)/2;
		double yy = (m[4]+1)/2;
		double zz = (m[8]+1)/2;
		double xy = (m[3]+m[1])/4;
		double xz = (m[6]+m[2])/4;
		double yz = (m[7]+m[5])/4;
		if ((xx > yy) && (xx > zz)) { // m[0][0] is the largest diagonal term
			if (xx< epsilon) {
				x = 0;
				y = 0.7071;
				z = 0.7071;
			} else {
				x = Math.sqrt(xx);
				y = xy/x;
				z = xz/x;
			}
		} else if (yy > zz) { // m[1][1] is the largest diagonal term
			if (yy< epsilon) {
				x = 0.7071;
				y = 0;
				z = 0.7071;
			} else {
				y = Math.sqrt(yy);
				x = xy/y;
				z = yz/y;
			}	
		} else { // m[2][2] is the largest diagonal term so base result on this
			if (zz< epsilon) {
				x = 0.7071;
				y = 0.7071;
				z = 0;
			} else {
				z = Math.sqrt(zz);
				x = xz/z;
				y = yz/z;
			}
		}
		return new axisAngle(angle,x,y,z); // return 180 deg rotation
	}
*/	// as we have reached here there are no singularities so we can handle normally

	double s = Math.sqrt((m[5] - m[7])*(m[5] - m[7])
		+(m[6] - m[2])*(m[6] - m[2])
		+(m[1] - m[3])*(m[1] - m[3])); // used to normalise
	if (Math.abs(s) < 0.001) s=1; 
		// prevent divide by zero, should not happen if matrix is orthogonal and should be
		// caught by singularity test above, but I've left it in just in case
	angle = Math.acos(( m[0] + m[4] + m[8] - 1)/2);
	x = (m[5] - m[7])/s;
	y = (m[6] - m[2])/s;
	z = (m[1] - m[3])/s;
  // return new axisAngle(angle,x,y,z);

outlet(0, + angle);
outlet(1, + x); 
outlet(2, + y);
outlet(3, + z);


	}
    
}




